/*
 * Copyright (c) 2019 - 2021 Stefan Strobel <stefan.strobel@shimatta.net>
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */

/**
 * @file    shellmatta_history.h
 * @brief   history buffer functions of shellmatta
 * @author  Stefan Strobel <stefan.strobel@shimatta.net>
 */

/**
 * @addtogroup shellmatta_history
 * @{
 */
#ifndef _SHELLMATTA_HISTORY_H_
#define _SHELLMATTA_HISTORY_H_

#include "shellmatta.h"
#include <stdint.h>

bool history_navigate(shellmatta_instance_t *inst, int32_t cnt);
void history_storeCmd(shellmatta_instance_t *inst);
void history_restoreCmd(shellmatta_instance_t *inst);
void history_reset(shellmatta_instance_t *inst);

#endif

/** @} */

